<HTML>
<HEAD>
  <!-- Created by AOLpress/1.2 -->
  <TITLE>Hall A Work and Cache Disks</TITLE>
</HEAD>

<BODY BGCOLOR="#ffffff" TEXT="#000040" LINK="#ff0000" VLINK="#ff0000">

<STRONG>
<H1 align=center><FONT COLOR="Black">
Info &nbsp; About &nbsp; Work &nbsp; and &nbsp;
Cache &nbsp; Disks &nbsp; in &nbsp; Hall A
</FONT></EM></STRONG>
<br><br>
</H1>

<P ALIGN=Left>
<FONT COLOR="Black">Robert Michaels, rom@jlab.org, Jefferson
Lab Hall A,  updated Aug, 2001
  <HR>
</FONT>

<P>
Firstly, general info about JLab computers (e.g. what is
a work or cache disk ?)
can be learned from the
<A HREF="http://cc.jlab.org">computer center</A>.
This page pertains to the management of Hall A 
work and cache disks.

<P>
<UL>
  <LI>
    <h3>WORK DISK on JLab CUE</h3>
</UL>
<P>

<P>
We have <FONT COLOR="Magenta">1.25 Terabytes</FONT>
 of scratch work disk on JLab's
Common Unix Environment (CUE).  
There are various physical partitions:  12 are 50 Gbytes
and 1 is 350 Gbyte, and 1 is 300 Gbyte.
Typically the 50 Gb partitions are
dedicated to "contemporary experiments"; the two larger ones 
are for everyone (including contemporary experiments).  
Contemporary experiments include the one running, the
one or two upcoming, and recent previous experiments.  
<P>
    To get to your work area, contemporary or not,
follow the link:  For the example of e98108, you
"cd /work/halla/e98108" on JLab computers.  If you are in the 
Unix group a-e98108 you can write there.  You must
be in the Unix group corresponding to your experiment.
Ask me to be added to a group or for other questions.
Some experiments have two disk areas, like 
/work/halla/e97103/disk1 and /work/halla/e97103/disk2,
usually one of these is the "dedicated" disk, the other
points to a region on a big "shared" disk.
<P>
    A "cleanup" script will maintain free space
on the work disks.  In simple terms, the largest 
and oldest files are deleted nightly, if necessary,
to keep some space free.  For the dedicated disks,
the spokespersons can elect to have me turn off
the cleanup script; but it will run on the big disk.
The cleanup script is described in the
appendix below. 
<P> 
   Another "cleanup" procedure, in addition to the
usual nightly one, will be to delete very old unused
files.  The criteria is that the modification date is
more than 3 years old and the access date is more than 
1 year old.  This will be done unannounced every few months.
<P>
<FONT COLOR="Red"><B> IMPORTANT: </B>
&nbsp;  Work disks have no backups.  Leave only things
on /work that you don't mind losing.  Do not confuse
/work, which is scratch space, with the central /home fileserver. 
</FONT>
<P>
    When an experiment loses its disk, its data
will be squeezed into one of the big general purpose disks, first
running "cleanup" with strict parameters to make space.
Afterwards you may still follow the link to get to your data.
<P>
<pre>
</pre>
<UL>
  <LI>
    <h3>ADAQ WORK DISKS</h3>
</UL>
<P>
Thanks to Ole Hansen, we also have several hundred GBytes of
work disk on the adaq Linux cluster (adaql machines, l = linux).
Disks are /adaqlN/workM
where N = 1,2...  and M = 1,2,3... &nbsp;
The running experiment may keep stuff there, e.g. huge
hbook files, etc.  But these disks are not backed up.
Also, a cleanup script operates there (see appendix).
At the end of the experiment, the adaq work disks are
cleaned up (files erased) to make room for the next
experiment.
<pre>
</pre>
<P>
<UL>
  <LI>
    <h3>CACHE DISK</h3>
</UL>
<P>
In addition to /work, there are two kinds of /cache disk.
One kind is ``hidden'' from users and is used to feed
the batch farm from data in MSS.  Another kind is open to
users and is the temporary repository for MSS data.
We presently have 1 Tbyte of the latter kind, spread among
/cache/halla/EXPERIMENT where EXPERIMENT corresponds
to different experiments.
See <A HREF="http://cc.jlab.org/scicomp">
Computer Center Scicomp pages</A>. &nbsp;
<pre>


</pre>
<FONT Color="Green"><B> APPENDIX -- Cleanup scripts </B></FONT>
<P>
For <FONT Color="Red"><B>WORK Disks on JLab CUE</B></FONT>  -- &nbsp; &nbsp;
Every night the disks are checked.  If less than 95% full, nothing happens.  
If greater than 95% full, files will be deleted as follows:  Initially,
files greater than NB bytes are considered, then NB/(10**i), i=1,2,3...(loop)
where NB is big.  I.e., first we consider 10 Gbyte files, then 1 Gbyte, then
100 Mbyte, etc.  At each level of filesize, files are sorted by last usage; 
oldest files considered first.  A file is deleted only if it has not been
used within NDAYS (= 7). After each deletion the disk usage is checked; 
when it falls below 90% the deletion stops.  This script can be
disabled for the dedicated disks at request of spokesperson,
but cannot be disabled for the general (shared) disks.
<pre>
</pre>
For <FONT Color="Red"><B>CACHE</B></FONT>
disks /cache/halla (experiment and home directories) -- &nbsp; &nbsp;
Every N hours each disk is checked.  Independently of how full the
disks are, usage is checked versus quotas.  Typical quotas are
12% for ``big'' experiments and 5% for ``small''.
If the directory is exceeding its
quota, files are marked for early deletion using "jcache -d",
according  to the following decision method. 
(First note, I do not actually delete files.  They only get marked
as candidates for deletion, and will be deleted if the disks
get full.)
Initially, files greater than NB bytes are considered, then NB/(2**i), 
i=1,2,3...(loop) where NB is big.  I.e. first we consider >10 Gbyte 
files, then 5 Gbyte, then 2.5 Gbyte, etc.  At each level of filesize, 
files are sorted by last usage; oldest files considered first.  A file 
is marked for deletion only if it has not been used within NDAYS 
(typically NDAYS = 3). After each "jcache -d" the directory's usage 
is decremented and checked versus quota. When the usage falls within 
quota, the marking for deletion stops.  
<pre>
</pre>
For <FONT Color="Red"><B>ADAQ WORK DISKS</B></FONT> in counting room.
The following algorithm will maintain space on the ADAQ Linux scratch disks
/adaqlN/dataM (N=1,2..) (M=1,2..).  &nbsp;
Every night each disk is checked.  If less than 95% full, nothing happens.  
If greater than 95% full, files will be deleted as follows:  Initially,
files greater than NB bytes are considered, then NB/(10**i), i=1,2,3...(loop)
where NB is big.  I.e., first we consider 10 Gbyte files, then 1 Gbyte, then
100 Mbyte, etc.  At each level of filesize, files are sorted by last usage; 
oldest files considered first.  A file is deleted ONLY IF it has not been
used within NDAYS (= 14). After each deletion the disk usage is checked; 
when it falls below 80% the deletion stops.  To prevent infinite looping,
the script quits trying after a number of files are considered; e.g. if the
users "touch" all files within NDAYS, nothing gets deleted.  The sorting
by filesize tends to avoid removing source files. To further avoid this
(and to avoid deleting "data") a file is not deleted if it contains a
key word like ".dat" or ".cxx" etc.  At then end of an experiment
<FONT COLOR="Blue">anything might be deleted</FONT> to make room
for the next experiment.
<pre>

</pre>
<address><A HREF="http://www.jlab.org/~rom/bobpage.html">
R. Michaels</A> &nbsp; -- &nbsp;
<B> e-mail: 
<A HREF="mailto:rom@jlab.org">rom@jlab.org</a>
</B>

</BODY></HTML>



